# -*- coding: utf-8 -*-
__author__ = 'TUMCIVIL'
__version__ = '2.0.0'
__title__ = 'Cleaning Data Level Walls'
__doc__ = """Created by : TUMCIVIL TEAM
Version : 2.0.0 
Update : วันที่ 03-03-2025
_________________________________________________________________
รายการ :
ลบค่าระดับท้องผนัง,หลังผนังและตำแหน่งทั้งหมดของ Parameter(Base EL 
Wall,Top EL Wall และ Location) ใน Model
_________________________________________________________________
ข้อจำกัดการใช้งาน :
1.ไม่สามารถใช้กับผนังที่ Slope ได้
2.ไม่สามารถใช้กับผนังที่สร้างจาก Model In-Place ได้
3.เมื่อใช้คำสั่ง Cleaning Data Walls แล้ว ค่าระดับท้องผนัง,หลังผนัง และ 
    ตำแหน่งระดับของผนัง (Location) จะถูกลบข้อมูลออกจาก Parameter 
    ใน Properties ในหัวข้อ Other เมื่อเลือกผนังใดๆ


_________________________________________________________________
วิธีการใช้ :
1.ไม่มี


 """
# for timing -------------------------------------------------------------------
import pyrevit.coreutils as cor
from pyrevit.coreutils import Timer
timer = Timer()
# ------------------------------------------------------------------------------
import sys
import csv
import codecs
import os.path as op
from collections import defaultdict

from pyrevit import PyRevitException
from pyrevit import forms
from pyrevit import coreutils
from pyrevit import revit, DB, HOST_APP
from pyrevit import script
import Autodesk
from Autodesk.Revit.DB import *
from Autodesk.Revit.UI import *
import Autodesk.Revit.DB as DB
from Autodesk.Revit.DB.Structure import *
import re

doc = __revit__.ActiveUIDocument.Document
uidoc = __revit__.ActiveUIDocument

def walls():
    walls = DB.FilteredElementCollector(doc).OfCategory(DB.BuiltInCategory.OST_Walls) \
        .WhereElementIsNotElementType() \
        .ToElements()

    # print("Data = {}".format(param_data))
    out = []
    for e in walls:
        q1 = ""
        q2 = ""
        q3 = ""
        q4 = ""
        q5 = ""
        q6 = ""
        q7 = ""
        t = Transaction(doc, 'change parameter')
        t.Start()
        # try:
        #     # e.LookupParameter("Name Core Wall").Set(q2)
        #     e.LookupParameter("Group").Set(q4)
        #     # e.LookupParameter("Base EL Wall").Set(q6)
        #     # e.LookupParameter("Top EL Wall").Set(q7)

        # except:
        #     # TaskDialog.Show('error', 'error message')
        #     pass
        try:
            e.LookupParameter("Location").Set(q1)
        except:
            pass
        try:
            e.LookupParameter("Base EL Wall").Set(q6)  # ตั้งค่า Base Level
        except:
            pass
        try:
            e.LookupParameter("Top EL Wall").Set(q7)  # ตั้งค่า Top Level
        except:
            pass
        try:
            e.LookupParameter("Strength Concrete").Set(q5)
        except:
            pass
        try:
            e.LookupParameter("Size").Set(q3)
        except:
            pass

        t.Commit()


if __name__ == "__main__":
    walls()

# for timing -------------------------------------------------------------------
print("====" * 20)
print("CLEANING DATA WALLS COMPLETELY !")
endtime = timer.get_time()
print("Time been used = {} sec.".format(endtime))
currentDate = cor.current_date()
currentTime = cor.current_time()
print ("Date : {} ; {}".format(currentDate,currentTime))
print ("Credited by : {}".format(__author__))
print("====" * 20)
# ------------------------------------------------------------------------------